//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string RsiT3Params = "25,0.7;35,0.7";
extern int    RsiT3Price  = PRICE_CLOSE;
extern bool   OriginalT3  = false;

double buffUp[];
double buffDn[];
double buffNe[];
double periods[][2];
string speriods[];
int    totalPeriods;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, buffUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, buffDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, buffNe); SetIndexStyle(2,DRAW_HISTOGRAM);
   
      //
      //
      //
      //
      //
      
      RsiT3Params = StringTrimLeft(StringTrimRight(RsiT3Params));
      if (StringSubstr(RsiT3Params,StringLen(RsiT3Params)-1,1) != ";")
                       RsiT3Params = StringConcatenate(RsiT3Params,";");

      //
      //
      //
      //
      //
                             
         int s =  0;
         int i =  StringFind(RsiT3Params,";",s);
         while (i > 0)
         {
            string current = StringSubstr(RsiT3Params,s,i-s);
            ArrayResize(speriods,ArraySize(speriods)+1);
                        speriods[ArraySize(speriods)-1] = current;
            s = i + 1;
            i = StringFind(RsiT3Params,";",s);
         }

         //
         //
         //
         //
         //
         
         totalPeriods = MathMin(ArraySize(speriods),10);
         ArrayResize(periods,totalPeriods);
         for (int k=0; k<totalPeriods; k++)
         {
            speriods[k] = speriods[k]+",";
            int p = 0;
                s = 0;
                i = StringFind(speriods[k],",",s);
                while (i > 0)
                {
                     current = StringSubstr(speriods[k],s,i-s);
                     periods[k][p] = StrToDouble(current);
                        s = i + 1;
                        i = StringFind(speriods[k],",",s);
                        p++;
                }                     
         }
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][20];
#define _rsi    0
#define _slope  1

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
         
   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double max   = 0;
      double sum   = 0;
      double price = iMA(NULL,0,1,0,MODE_SMA,RsiT3Price,i);
      for (int k=0; k<totalPeriods; k++)
      {
         max++;
         int    kk = k*2;
         int    RsiPeriod = periods[k][0];
         double Hot       = periods[k][1];

         //
         //
         //
         //
         //
                  
         work[r][kk+_rsi]   = iRsi(price,RsiPeriod,Hot,OriginalT3,i,k);
         work[r][kk+_slope] = work[r-1][kk+_slope];
            if (work[r][kk+_rsi]>work[r-1][kk+_rsi]) work[r][kk+_slope]= 1;
            if (work[r][kk+_rsi]<work[r-1][kk+_rsi]) work[r][kk+_slope]=-1;
                     sum += work[r][kk+_slope];
      }

      //
      //
      //
      //
      //
      
      buffUp[i] = EMPTY_VALUE;
      buffDn[i] = EMPTY_VALUE;
      buffNe[i] = EMPTY_VALUE;
         if (sum== max) buffUp[i] = 1;
         if (sum==-max) buffDn[i] = 1;
         if (buffDn[i]==EMPTY_VALUE && buffUp[i]==EMPTY_VALUE) buffNe[i] = 1;
         
   }      
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workRsi[][10];
#define _price  0

double iRsi(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars); workRsi[Bars-i-1][_price+instanceNo] = price;
   
   //
   //
   //
   //
   //
   
   double chng   = workRsi[Bars-i-1][_price+instanceNo]-workRsi[Bars-i-2][_price+instanceNo];
   double change = iT3(        chng ,period,hot,original,i,2*instanceNo+0);
   double changa = iT3(MathAbs(chng),period,hot,original,i,2*instanceNo+1);
      if (changa != 0)
            return(MathMin(MathMax(50.0*(change/MathMax(changa,0.0000001)+1.0),0),100));
      else  return(50.0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][120];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}